//                     lattice.cpp
                         
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <list>
#include <algorithm>
#include <functional>
#include <cmath>
#include <cstdlib>

using namespace std;


typedef vector<vector<double> > Matrix;
std::vector<double> M;

template<class T>
void Print(const vector<vector<T> >& vec, const double &H, const double &d, int nx, const double &o, const double &f, int G, int K);

Matrix TVS(const double &a, const double &l, const double &d, const double &X, const double &Y);

bool inside ( const double & x, const double & y, 
              const double & r, const double & R )
{
  if ( x == 0 && y == 0 ) return r <= R;
  double t = 1 + sqrt ( r*r / ( x*x + y*y ) );
  double xe = t * x, ye = t * y;
  return xe*xe + ye*ye <= R*R;
}

void PrintAZ(double, double);

unsigned int NN;

int main ()
{
  char z;
  int QQ;
  double R, a, H, Radius;
  cout<<"Input please radius of active zone: ";
  cin>>R;
  cout<<"heigh of active zone: ";
  cin>>H;
  cout<<"size of cell (fuel assembly):  ";
  cin>>a;

  
cout<<"Has a lattice internal straucture[Y/N]? ";
cin>>z;
cin.ignore(1024, '\n');

 

  double dx = a;
  double dy = 1.5 * a / sqrt(3);

  double x0 = dx * static_cast<int>( R / dx );  // edge point
  double y0 = dy * static_cast<int>( R / dy );  // edge point

  ofstream out ( "lattice.dat" );
  ofstream mat ( "material.dat" );

  vector < vector < pair < double, double > > > res;

  for ( double y = 0; y <= y0; y += dy ) {

    vector < pair < double, double > > line;

    for ( double x = -x0; x <= x0; x += dx )
      if ( inside ( x, y, a/4.4, R ) )
        line.push_back ( make_pair ( x, y ) );

    res.push_back ( line );
    if ( y != 0 ) {
      for ( unsigned int i = 0; i < line.size(); ++i ) 
        line[i].second = -line[i].second;
      res.insert ( res.begin(), line );
    }

    x0 += dx / 2;

    //cout << line.size() << endl;
  }

  out.setf(ios::right,ios::adjustfield);
  out.precision(4);

  NN = 0;
  for ( unsigned int j = 0; j < res.size(); ++j ) 
    NN += res[j].size();
 cout << " Number of cells N = " << NN << endl;
if (z=='N' || z=='n')
{  
 cout<<"Input please radius of hols in cell: ";
 cin>>Radius;

  cout<<"number of nuclear components:  ";
  cin>>QQ;
  
M.resize(QQ);

for(int t=0; t<QQ; t++)
{
cout<<"volum ratios of nuclear components:   ";
cin>>M[t];
}

 for(int u=0; u<NN; u++) // creating material.dat 
{ 
    for(int g=0; g<QQ; g++)
    { 
     mat<<M[g]<<"  ";
    }
mat<<endl;
}
  
 NN += 4; // += outer volumes

  --NN; // Cascade::NZONE-1
out << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << -(H/2+100+5+100) //half-height of concrete  
      << setw(12) << H/2+100+5+100   //half-height of concrete  
      << setw(12) << (R+100+5+100)    //radius of concrete    
      << setw(12) << 0
      << setw(12) << 2.3 << endl;        //type of geometry - cylinder 
  out << 2 << " ";
  for(int q=3;q<NN;q++)                  //numbers of included geometrical elements
    out << 0 << " ";
  out <<endl;

out << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << -(H/2+100+5)  //half-height of tank
      << setw(12) << H/2+100+5     //half-height of tank 
      << setw(12) << (R+100+5)      //radius of tank 
      << setw(12) << 0
      << setw(12) << 2.3 << endl;
  out << 3 << " ";
  for(int q=2;q<NN;q++)
    out << 0 << " ";
  out <<endl;
  
out << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << -(H/2+100)  //half-height of reflector
      << setw(12) << (H/2+100)   //half-height of reflector
      << setw(12) << (R+100)      //radius of reflector
      << setw(12) << 0
      << setw(12) << 2.3 << endl;
  out << 4 << " ";
  for(int q=1;q<NN;q++)
    out << 0 << " ";
  out <<endl;
  
  out << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << 0
      << setw(12) << -H/2   //half-height of active zone
      << setw(12) << H/2    //half-height of active zone
      << setw(12) << R      //radius of active zone
      << setw(12) << 0
      << setw(12) << 2.3 << endl;
  for(int q=5;q<=NN;q++)
    out << q << " ";
  out <<endl;

// creation of lattice

  for ( unsigned int i = 0; i < res.size(); ++i ) {
    for ( unsigned int j = 0; j < res[i].size(); ++j ) {
      out << setw(12) << ( fabs ( res[i][j].first ) < 1e-4 ? 0 : res[i][j].first )
          << setw(12) << 0
          << setw(12) << ( fabs ( res[i][j].second ) < 1e-4 ? 0 : res[i][j].second )
          << setw(12) << 0
          << setw(12) << -H/2
          << setw(12) << H/2
          << setw(12) << Radius
          << setw(12) << 0
          << setw(12) << 2.3 << endl;
      for(int q=0;q<NN;q++)
        out << "0 ";
      out << endl;
    }
  }

  return 0;
}
else
{
  if ( z !='Y' && z != 'y' ) cerr<<"Ok! I'll take it as \"Yes\""<<endl;

  double l, d,f, o;
  int nx,ny, MM;
  vector<double>::size_type N;


cout<<"lattice spacing: ";
cin>>l;
cout<<"diameter of fuel rod: ";
cin>>d;
cout<<"outer diameter of fuel pellet: ";
cin>>o;
cout<<"internal diameter of fuel pellet: ";
cin>>f;
 
  cout<<"number of nuclear components:  ";
  cin>>MM;
  
 Matrix MT(3);
 MT[0].resize(MM);
 MT[1].resize(MM); 
 MT[2].resize(MM);

 nx=static_cast<int>( ((2*a/sqrt(3)-2*(l-d)-d)/l)+1 ); // numbers of fuel rods in  dioganal

  ny=static_cast<int>( ((a/sqrt(3)-d/2-(l-d))/l) );      // half namber of rows in  fuel assambly
  
  N=(nx*ny-(ny+1)*ny/2)+nx;

    


for(int EE=0; EE<MM; EE++)
{
cout<<"volum ratios of nuclear components of shel of fuel rod:   ";
cin>>MT[0][EE];
}

for(int EE1=0; EE1<MM; EE1++)
{
cout<<"volum ratios of nuclear components of fuel pellet:   ";
cin>>MT[1][EE1];
}

for(int EE2=0; EE2<MM; EE2++)
{
cout<<"volum ratios of nuclear components of internal hole of fuel pellet:   ";
cin>>MT[2][EE2];
}



 for(int u1=0; u1<NN*(2*N-nx); u1++) // creating material.dat 
{ 
    for(int g1=0; g1<MM; g1++)
    { 
     mat<<MT[0][g1]<<"  ";
    }
mat<<endl;

  for(int g2=0; g2<MM; g2++)
    { 
     mat<<MT[1][g2]<<"  ";
    } 
 mat<<endl;

 for(int g3=0; g3<MM; g3++)
    { 
     mat<<MT[2][g3]<<"  ";
    } 
 mat<<endl;

}




  Matrix MatrixTVS(4);
  MatrixTVS[0].resize(N);
  MatrixTVS[1].resize(N);
  MatrixTVS[2].resize(N);
  MatrixTVS[3].resize(N);
 
int G=3;
int K=0;
  
for ( unsigned int i = 0; i < res.size(); ++i ) {
    for ( unsigned int j = 0; j < res[i].size(); ++j ) {
  
   MatrixTVS=TVS(a,l,d, res[i][j].first, res[i][j].second);
   PrintAZ(R, H);
   Print(MatrixTVS,H,d,nx,o,f, G, K);

   G=G+3*(2*N-nx);
   K=K+3*(2*N-nx);

  } 
  }
  
return 0;
}

}

Matrix TVS(const double &a, const double &l, const double &d, const double &X, const double &Y)
{
  
  int nx,ny,min;
  double x0,y0;
  vector<double>::size_type k,L,N;
  nx=static_cast<int>( ((2*a/sqrt(3)-2*(l-d)-d)/l)+1 ); // numbers of fuel rods in   dioganal
  ny=static_cast<int>( ((a/sqrt(3)-d/2-(l-d))/l) );      // half namber of rows in  fuel assambly
  N=(nx*ny-(ny+1)*ny/2)+nx ;
  
  Matrix kord(3);
  Matrix rot(4);
  kord[0].resize(N);
  kord[1].resize(N);
  kord[2].resize(N);
  
  rot[0].resize(N);
  rot[1].resize(N);
  rot[2].resize(N);
  rot[3].resize(N);


  min=nx-ny;
 
   L=1;
   x0=(X-3*sqrt(3)*l)*sqrt(3)/2+(Y-3*l)*0.5;
   y0=-(X-3*sqrt(3)*l)*0.5+(Y-3*l)*sqrt(3)/2;

 for( int n=nx; n>=min;n--){
    for( int j=0; j<=(n-1); j++){
      k=L+j-1;  
      kord[0][k]=x0+j*l;
      kord[1][k]=y0;
      kord[2][k]=-kord[1][k];
    }
    y0=y0+sqrt(3)*l/2;
    x0=x0+l/2;
    L=L+n;
  }
  
 for(unsigned int h=0;h<kord[0].size();++h) 
    {
      
    rot[0][h]=kord[0][h]*(sqrt(3)/2)-kord[1][h]*0.5;
 
      rot[1][h]=kord[0][h]*0.5+kord[1][h]*(sqrt(3)/2);
      rot[2][h]=kord[0][h]*(sqrt(3)/2)-kord[2][h]*0.5;
      rot[3][h]=kord[0][h]*0.5+kord[2][h]*(sqrt(3)/2);
    }


 return rot;
} 

template<class T>
void Print(const vector<vector<T> >& vec, const double &H, const double &d, int nx, const double &o, const double &f, int G, int K)
{
 
 ofstream out ( "lattice.dat", ios::app );
 out.setf(ios::left,ios::adjustfield);
 out.precision(4);
 
  int M,D,B;

  D=G+1;
  
  for( unsigned int h=0;h<vec[0].size();++h) 
    {
      out<<setw(13)<<vec[0][h]<<setw(13)<<"0"<<setw(13)<<vec[1][h]<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13);
      out<<H/2<<setw(13)<<d/2<<setw(13)<<"0"<<setw(13)<<"2.3"<<endl;
        
           
      M=G+h;
  
     out<<M<<" "<<M+1<<" ";
    
    for(int u=0;u<(NN*3*(2*vec[0].size()-nx)-2);u++)
        {
          out<<"0"<<" ";
        }
        
      out<<endl;
      G=G+2;
      
      out<<setw(13)<<vec[0][h]<<setw(13)<<"0"<<setw(13)<<vec[1][h]<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13);
      out<<H/2<<setw(13)<<o/2<<setw(13)<<"0"<<setw(13)<<"2.3"<<endl;
      
      B=D+h;
    
      out<<B<<" ";
     
     for(int c=0;c<(NN*3*(2*vec[0].size()-nx)-1);c++)
        {
          out<<"0"<<" ";
        }
      out <<endl;
      D=D+2;
 
      out<<setw(13)<<vec[0][h]<<setw(13)<<"0"<<setw(13)<<vec[1][h]<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13);
      out<<H/2<<setw(13)<<f/2<<setw(13)<<"0"<<setw(13)<<"2.3"<<endl;
     
   
   for(int w=0;w<(NN*3*(2*vec[0].size()-nx));w++)
        {
          out<<"0"<<" ";
        }
      out<<endl;
       }

   
  int F,S,A;
  K=K+3*vec[0].size()+3-nx;
  S=K+1;
  for(unsigned int q=nx;q<vec[0].size(); ++q) 
        {
          out<<setw(13)<<vec[0][q]<<setw(13)<<"0"<<setw(13)<<vec[2][q]<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13);
          out<<H/2<<setw(13)<<d/2<<setw(13)<<"0"<<setw(13)<<"2.3"<<endl;
          
          F=K+q;
    
        out<<F<<" "<<F+1<<" ";
        
        for(int e=0;e<(NN*3*(2*vec[0].size()-nx)-2); e++)
            {
              out<<"0"<<" ";
            }
          
          out<<endl;
          K=K+2;
          
          out<<setw(13)<<vec[0][q]<<setw(13)<<"0"<<setw(13)<<vec[2][q]<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13);
          out<<H/2<<setw(13)<<o/2<<setw(13)<<"0"<<setw(13)<<"2.3"<<endl;
          
          A=S+q;
          out<<A<<" ";
     
       
       for(int a=0;a<(NN*3*(2*vec[0].size()-nx)-1);a++)
            {
              out<<"0"<<" ";
            }
          out <<endl;
          S=S+2;
          
          out<<setw(13)<<vec[0][q]<<setw(13)<<"0"<<setw(13)<<vec[2][q]<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13);
          out<<H/2<<setw(13)<<f/2<<setw(13)<<"0"<<setw(13)<<"2.3"<<endl;
         
         for(int s=0;s<(NN*3*(2*vec[0].size()-nx));s++)
            {
              out<<"0"<<" ";
        }
          out<<endl;
       
     }
  
 }

 void PrintAZ(double R, double H)
{
 ofstream out ( "TVS.dat", ios::app );
 out.setf(ios::left,ios::adjustfield);
 out.precision(4);
 out<<setw(13)<<"0"<<setw(13)<<"0"<<setw(13)<<"0"<<setw(13)<<"0"<<setw(13)<<-H/2<<setw(13)<<H/2<<setw(13)<<R<<setw(13);
 out<<"0"<<setw(13)<<"2.3"<<setw(13)<<endl;
 
for(int t=0; t<100; t++)
 {
    out<<2+3*t<<" ";
 }
   out<<endl;
}